From 19b49db7a31387b65548167f73aeabbbbe60c3ab Mon Sep 17 00:00:00 2001
From: Barton Schaefer <schaefer@zsh.org>
Date: Mon, 20 May 2013 22:44:03 -0700
Subject: [PATCH] upon "read" of a short line, assign all variables passed as arguments.

It was noted that (print 1 2 | read one two three four) assigned values
only to $one and $two except in the case where EOF was reached.
---
 Src/builtin.c |    2 +-
 1 files changed, 1 insertions(+), 1 deletions(-)

diff --git a/Src/builtin.c b/Src/builtin.c
index cd88643..bc91578 100644
--- a/Src/builtin.c
+++ b/Src/builtin.c
@@ -5674,7 +5674,7 @@ bin_read(char *name, char **args, Options ops, UNUSED(int func))
 	    zputs(buf, stdout);
 	    putchar('\n');
 	}
-	if (!OPT_ISSET(ops,'e') && (*buf || first)) {
+	if (!OPT_ISSET(ops,'e') && (*buf || first || gotnl)) {
 	    if (OPT_ISSET(ops,'A')) {
 		addlinknode(readll, buf);
 		al++;
-- 
1.7.0.4

